%% Example for Wavelet transform

image = double(imread('cameraman.tif'));
figure; imshow(image,[]);
title('Original image', 'FontSize', 16);

wavelet_op = Wavelet('Daubechies',4,6);
wavelet_coef = wavelet_op*image;
figure; imshow(abs(wavelet_coef),[0,700])
title('Wavelet coefficients','FontSize', 16);

thre = 15;
wavelet_coef_thre = wavelet_coef.*(abs(wavelet_coef)>thre);
image_comp = wavelet_op'*wavelet_coef_thre;
comp_ratio = sum(wavelet_coef(:)~=0)/sum(wavelet_coef_thre(:)~=0);
figure; imshow(image_comp,[])
title(sprintf('compressed image (using Wavelet, ratio=%1.1f)',comp_ratio), 'FontSize',16)