%% Example for Wavelet transform

load('mri.mat','D');
image = double(D(:,:,1,16));
image = imresize(image, [256,256]);
figure; imshow(abs(image),[]);
title('Original image', 'FontSize', 16);

wavelet_op = Wavelet('Daubechies',4,6);
wavelet_coef = wavelet_op*image;
figure;imshow(abs(wavelet_coef),[0,300])
title('Wavelet coefficients','FontSize', 16);

thre = 5;
wavelet_coef_thre = wavelet_coef.*(abs(wavelet_coef)>thre);
image_comp = wavelet_op'*wavelet_coef_thre;
comp_ratio = sum(wavelet_coef(:)~=0)/sum(wavelet_coef_thre(:)~=0);
figure; imshow(abs(image_comp),[]);
title(sprintf('Compressed image (using Wavelet, ratio=%1.1f)',comp_ratio), 'FontSize',12)

